// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'phGridTree.pas' rev: 6.00

#ifndef phGridTreeHPP
#define phGridTreeHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <phBabGridContent.hpp>	// Pascal unit
#include <phDataTraveser.hpp>	// Pascal unit
#include <phDataEntityPack.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Phgridtree
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TIntegrationEventKind { ieInsert, ieRemove, ieSelectionChanged, ieVisibleChanged, ieMovePerfomed, ieUnload, ieLoad, ieInvalidate };
#pragma option pop

typedef void __fastcall (__closure *TOnIntegrationEvent)(TIntegrationEventKind aIntegrationEventKind, Phdataentitypack::TphDataEntity* aDataEntity);

class DELPHICLASS TphGridTree;
class DELPHICLASS TphDataEntity_GridTreeNode;
typedef void __fastcall (__closure *TOnContentChangeEvent)(TphGridTree* aGridTree, TphDataEntity_GridTreeNode* aDataEntity);

typedef void __fastcall (__closure *TOnTreeControllerCallBackInitSubList)(TphGridTree* aGridTree, TphDataEntity_GridTreeNode* aDataEntity_GridTreeNode);

typedef void __fastcall (__closure *TOnExpandCollapseEvent)(TphGridTree* aGridTree, TphDataEntity_GridTreeNode* aDataEntity, bool &allow);

class DELPHICLASS TphDataList_GridTree;
class PASCALIMPLEMENTATION TphDataList_GridTree : public Phdataentitypack::TphDataList 
{
	typedef Phdataentitypack::TphDataList inherited;
	
protected:
	TphDataEntity_GridTreeNode* fOwningDataEntity;
	TphGridTree* fGridTree;
	
public:
	virtual void __fastcall AddUnloaded(int x);
public:
	#pragma option push -w-inl
	/* TphDataList.Destroy */ inline __fastcall virtual ~TphDataList_GridTree(void) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TphExposable.Create */ inline __fastcall TphDataList_GridTree(void) : Phdataentitypack::TphDataList() { }
	#pragma option pop
	
};


class PASCALIMPLEMENTATION TphDataEntity_GridTreeNode : public Phdataentitypack::TphDataEntity 
{
	typedef Phdataentitypack::TphDataEntity inherited;
	
private:
	System::TObject* fIntegrationCookie;
	void __fastcall SetExpanded(const bool Value);
	int __fastcall GetLevel(void);
	void __fastcall SetImageIndex(const int Value);
	void __fastcall SetSelectedIndex(const int Value);
	void __fastcall UpdateVisibility(void);
	void __fastcall InitGridRow(void);
	bool __fastcall Get_HideNode(void);
	void __fastcall Set_HideNode(const bool Value);
	TphDataList_GridTree* __fastcall GetSubDataList(void);
	int __fastcall GetSubDataListCount(void);
	TphGridTree* __fastcall GetGridTree(void);
	
protected:
	TphDataList_GridTree* fSubDataList;
	int fImageIndex;
	int fSelectedIndex;
	bool fExpanded;
	bool fSubDataListInitiated;
	Phbabgridcontent::TAxisContentItem* fAxisContentItem;
	bool fHidden;
	bool fHideNode;
	virtual void __fastcall CleanForFree(void);
	void __fastcall SetHidden(const bool Value);
	
public:
	virtual void __fastcall AfterCreate(Phdataentitypack::TphDataList* thephDataList);
	TphDataEntity_GridTreeNode* __fastcall ParentNode(void);
	TphDataEntity_GridTreeNode* __fastcall GetPrevVisible(void);
	TphDataEntity_GridTreeNode* __fastcall GetNextVisible(void);
	TphDataEntity_GridTreeNode* __fastcall GetNext(void);
	TphDataEntity_GridTreeNode* __fastcall GetPrev(void);
	bool __fastcall IsVisible(void);
	__property int Level = {read=GetLevel, nodefault};
	__property TphDataList_GridTree* SubDataList = {read=GetSubDataList};
	__property int SubDataListCount = {read=GetSubDataListCount, nodefault};
	__property int ImageIndex = {read=fImageIndex, write=SetImageIndex, nodefault};
	__property int SelectedIndex = {read=fSelectedIndex, write=SetSelectedIndex, nodefault};
	__property bool Expanded = {read=fExpanded, write=SetExpanded, nodefault};
	__property bool SubDataListInitiated = {read=fSubDataListInitiated, nodefault};
	__property Phbabgridcontent::TAxisContentItem* AxisContentItem = {read=fAxisContentItem, write=fAxisContentItem};
	__property TphGridTree* GridTree = {read=GetGridTree};
	__property bool HideNode = {read=Get_HideNode, write=Set_HideNode, nodefault};
	__property System::TObject* IntegrationCookie = {read=fIntegrationCookie, write=fIntegrationCookie};
public:
	#pragma option push -w-inl
	/* TphDataEntity.Destroy */ inline __fastcall virtual ~TphDataEntity_GridTreeNode(void) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TphExposable.Create */ inline __fastcall TphDataEntity_GridTreeNode(void) : Phdataentitypack::TphDataEntity() { }
	#pragma option pop
	
};


class PASCALIMPLEMENTATION TphGridTree : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	TOnIntegrationEvent fOnIntegrationEvents;
	TOnContentChangeEvent fOnInsertItem;
	TOnContentChangeEvent fOnDeleteItem;
	int fGridReload;
	int fGridUnload;
	TOnExpandCollapseEvent fOnExpand;
	TOnExpandCollapseEvent fOnCollapse;
	void __fastcall HandleMoveOfTreeNode(TphDataEntity_GridTreeNode* node);
	void __fastcall SetExpandedState(Phdataentitypack::TphDataList* aDataList, bool aExpanded);
	void __fastcall DeInitSubList(TphDataEntity_GridTreeNode* aDataEntity);
	
protected:
	Phdataentitypack::TphDataList* fRootDataEntities;
	Phdataentitypack::TphDataList2lev* fAllSubLists;
	Phbabgridcontent::TBabGridCell* fGridCell;
	Phdataentitypack::TphListController* fListController;
	TOnTreeControllerCallBackInitSubList fTreeControllerCallBackInitSubList;
	void __fastcall CleanNode(Phdataentitypack::TphDataList* theList);
	virtual void __fastcall _DeleteItem(Phdataentitypack::TphDataEntity* sender);
	virtual void __fastcall _InsertItem(Phdataentitypack::TphDataEntity* sender);
	virtual void __fastcall _SelectionChanged(Phdataentitypack::TphDataList* thephDataList, Phdataentitypack::TphDataEntity* theDataEntity);
	virtual void __fastcall _ContentChanged(Phdataentitypack::TphDataList* Sender);
	virtual void __fastcall _OnUnLoadedContentChanged(Phdataentitypack::TphDataList* Sender);
	virtual int __fastcall _SortCompare(Phdataentitypack::TphDataEntity* theDataEntity1, Phdataentitypack::TphDataEntity* theDataEntity2);
	virtual void __fastcall _OnVisibleChanged(Phdataentitypack::TphDataEntity* sender);
	virtual void __fastcall _InitSubDataList(Phdataentitypack::TphDataEntity* sender);
	virtual void __fastcall _OnHandlePerformedMove(Phdataentitypack::TphDataEntity* sender, int theOldIndex, int theNewIndex);
	virtual void __fastcall _OnEnterOwnerAfterChange(Phdataentitypack::TphDataEntity* theDataEntity);
	void __fastcall _OnLoadItem(Phdataentitypack::TphDataEntity* sender);
	void __fastcall _OnUnloadItem(Phdataentitypack::TphDataEntity* sender, bool &CanUnload);
	void __fastcall _OnExpand(TphDataEntity_GridTreeNode* sender, bool &allow);
	void __fastcall _OnCollapse(TphDataEntity_GridTreeNode* sender, bool &allow);
	virtual TphDataList_GridTree* __fastcall CreateDataList_GridTree(void);
	virtual Phdataentitypack::TphDataList2lev* __fastcall CreateDataList2Lev(void);
	virtual TMetaClass* __fastcall GetClassOfDataEntity_GridTreeNode(void);
	
public:
	__fastcall virtual TphGridTree(TOnTreeControllerCallBackInitSubList aTreeControllerCallBackInitSubList);
	__fastcall virtual ~TphGridTree(void);
	void __fastcall IntegrationTargetInvalidate(void);
	void __fastcall _OnGridRowReload(Phbabgridcontent::TAxisContentItem* aAxisContentItem);
	void __fastcall _OnGridRowUnload(Phbabgridcontent::TAxisContentItem* aAxisContentItem, bool UnloadPerform, bool &CanUnload);
	void __fastcall _OnKeepGridRowAfterUnload(Phbabgridcontent::TAxisContentItem* aAxisContentItem, bool &KeepAfterUnload);
	void __fastcall _OnUnloadIntervall(Phbabgridcontent::TAxisContentItem* aAxisContentItem, int &Start, int &Stop);
	void __fastcall _OnDeleteOfUnloaded(Phbabgridcontent::TAxisContentList* axList, int Start, int Stop);
	TphDataEntity_GridTreeNode* __fastcall InsertDataEntity(TphDataEntity_GridTreeNode* theOwningNode, int theIndex);
	TphDataEntity_GridTreeNode* __fastcall AddDataEntity(TphDataEntity_GridTreeNode* theOwningNode);
	void __fastcall RemoveDataEntity(TphDataEntity_GridTreeNode* theDataEntity);
	void __fastcall ExpandAll(void);
	void __fastcall CollapseAll(void);
	__property Phbabgridcontent::TBabGridCell* GridCell = {read=fGridCell, write=fGridCell};
	__property Phdataentitypack::TphDataList2lev* AllSubLists = {read=fAllSubLists};
	__property Phdataentitypack::TphDataList* RootDataEntities = {read=fRootDataEntities};
	__property TOnIntegrationEvent OnIntegrationEvents = {read=fOnIntegrationEvents, write=fOnIntegrationEvents};
	__property TOnContentChangeEvent OnInsertItem = {read=fOnInsertItem, write=fOnInsertItem};
	__property TOnContentChangeEvent OnDeleteItem = {read=fOnDeleteItem, write=fOnDeleteItem};
	__property TOnExpandCollapseEvent OnExpand = {read=fOnExpand, write=fOnExpand};
	__property TOnExpandCollapseEvent OnCollapse = {read=fOnCollapse, write=fOnCollapse};
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Phgridtree */
using namespace Phgridtree;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// phGridTree
